// Видеообзоры и уроки работы с ARDUINO на YouTube-канале IOMOIO: https://www.youtube.com/channel/UCmNXABaTjX_iKH28TTJpiqA

#include <HX711.h>                                  // Подключаем библиотеку HX711 для работы с АЦП hx711

HX711 scale(A1, A0);                                // Указываем в какие пины подключен АЦП hx711 (DT(DOUT)  - pin A1, SCK - pin A0)

                                 
float myScaleL=0;  // Инициализируем переменную в которой будем хранить текущий вес
float X;           // корректирующий коэф для тэна

unsigned long myScaleMillis = 0;

void setup() {
  Serial.begin(9600);                               // Инициализируем монитор порта, как устройство вывода
  Serial.println("Calibration...");                 // Выводим надпись
scale.set_scale(385.30);                          // Устанавливаем калибровочный коэффициент 
myScaleL = scale.get_units(20);                    // запоминаем вес 

  Serial.println(myScaleL);// Обнуляем значение веса на мониторе порта
}

void loop() {
                                                
if (millis() - myScaleMillis >= 30000){            // ждем 30 секунд
myScaleMillis = millis(); 
scale.power_up();                                 // Отключаем энергосберегающий режим hx711
float myScaleH=scale.get_units(20);                 // Запоминаем текущий вес
float Y=myScaleH-myScaleL;                          // определяем разницу в весе
// определяем коэф. корректировки для тэна
if (Y >= 1.80 &&  Y <= 2.19) X=0.00;
else if (Y >= 1.67 && Y < 1.80) X=0.10; 
else if (Y < 1.66) X=0.20;
else if (Y > 2.19 && Y <= 2.33) X= -0.10;
else if (Y >2.33) X= -0.20;

myScaleL = myScaleH;
scale.power_down();                               // Включаем энергосберегающий режим hx711
Serial.println("     ");                                                     
Serial.println(myScaleH); 
Serial.println(Y);  
Serial.println(X); 
}
}
